// archivo cfecha.cpp
// funciones y operadores de la clase cfecha

#include <time.h>		// time(); localtime();
#include <iomanip.h>		// setw(int w); setfill(char c);
#include "cfecha.h"

int	cfecha::diames[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};		// das de cada mes
char	*cfecha::semana[] = {"Jueves ", "Virnes ", "Sbado ", "Domingo ", "Lunes ", "Martes ", "Mircoles "};

 // Constructor por defecto
cfecha::cfecha(void)
    {
	dia = 1;
	mes = 1;			// fecha por defecto
	ano = 2001;
    }

// Constructor general
cfecha::cfecha(int d, int m, int a)
    {
	dia = d;
	mes = m;
	ano = a;
    }

// Constructor de copia
cfecha::cfecha(const cfecha &a)
    {
	dia = a.dia;
	mes = a.mes;
	ano = a.ano;
    }

					// SetThings
// funcin miembro setdate()
void cfecha::setdate(void)
    {
	cout << "\n\tIntroduzca el nmero de da: ";
	cin >> dia;
	cout << "\n\tIntroduzca el nmero de mes: ";		// ingreso de dia, mes y ao.
	cin >> mes;
	cout << "\n\tIntroduzca el ao: ";
	cin >> ano;
    }

// funcin miembro setday()
void cfecha::setday(int d)
    {
	dia = d;
    }

// funcin miembro setmonth()
void cfecha::setmonth(int m)
    {
	mes = m;
    }

// funcin miembro setyear()
void cfecha::setyear(int a)
    {
	ano = a;
    }

					// GetThings
// funcin miembro getday()
char *cfecha::getday(void) const
    {
	int x;
	
	x = ano*365 + int(ano/4) + sumadiames(mes-1) + dia;	// clculo total de das de una fecha
	if(ano%4 > 0 || (ano%4 == 0 && mes > 2))
	    ++x;
	
	return semana[x%7];					// traspaso de n de das  y retorno
    }								// 	de "da de la semana".

// funcin miembro getnday()
int cfecha::getnday(void) const
    {
	return dia;
    }

// funcin miembro getmonth()
int cfecha::getmonth(void) const
    {
	return mes;
    }

// funcin miembro getyear()
int cfecha::getyear(void) const
    {
	return ano;
    }

// Funcin miembro esttica today()
// retorna referencia a objeto cfecha,con la fecha actual
cfecha cfecha::today(void)
    {
    	time_t	now;
    struct tm	*ptm;
    	cfecha	hoy;
    	
    	time(&now);					// uso de time() y localtime() para la
    	ptm = localtime(&now);				//    obtencin de la fecha de hoy
    	
    	hoy.dia = ptm->tm_mday;				// asignacin de dia, mes y ao en objeto
    	hoy.mes = ptm->tm_mon + 1;			// 	  de la clase cfecha
    	hoy.ano = ptm->tm_year + 1900;
    	
    	return hoy;					// retorno de objeto con la fecha de hoy
    }

// Sobrecarga operadores aritmticos
// operador miembro + sobrecargado
cfecha cfecha::operator+(const cfecha &a)
    {
	double x, y;
	
	x = ano*365 + int(ano/4) + sumadiames(mes-1) + dia;		// traspaso a das de operando 1
	if(ano%4 > 0 || (ano%4 == 0 && mes > 2))
	    ++x;

	y = a.ano*365 + int(a.ano/4) + sumadiames(a.mes-1) + a.dia;	// traspaso a das de operando 2
	if(a.ano%4 > 0 || (a.ano%4 == 0 && a.mes > 2))
	    ++y;

	x = x + y;							// suma de operandos 1 y 2
	
	return cfecha::restaura(x);					// retorno de objeto con el
    }									//   resultado de la suma

// operador miembro - sobrecargado
cfecha cfecha::operator-(const cfecha &a)
    {
	double x, y;
	
	x = ano*365 + int(ano/4) + sumadiames(mes-1) + dia;		// traspaso a das de operando 1
	if(ano%4 > 0 || (ano%4 == 0 && mes > 2))
	    ++x;

	y = a.ano*365 + int(a.ano/4) + sumadiames(a.mes-1) + a.dia;	// traspaso a das de operando 2
	if(a.ano%4 > 0 || (a.ano%4 == 0 && a.mes > 2))
	    ++y;
	
	x = x - y;							// resta de operandos 1 y 2
	
	return cfecha::restaura(x);					// retorno de objeto con el
    }									//   resultado de la resta

// Sobrecarga pre operador de incremento ++
void cfecha::operator++(void)
    {
    	dia++;								// incremento de fecha en un da
    	if(dia>diames[mes] && (dia != 29 || mes != 2 || ano%4 != 0))
    	    {
    	    	dia = 1;
    	    	mes++;
    	    	if(mes == 13)
    	    	    {
    	    	    	mes = 1;
    	    	    	ano++;
    	    	    }
    	    }
    }

// Sobrecarga pre operador de decremento --
void cfecha::operator--(void)
    {
    	dia--;								// decremento de fecha en un da
    	if(dia == 0)
    	    {
		mes--;
		if(mes == 0)
		    {
		    	mes = 12;
		    	ano--;
		    }
		if(mes != 2 && ano%4 != 0)
    	    	    {
			dia = diames[mes];
		    }
		 else
		    	dia = 29;
    	    }
    }

// Sobrecarga operador de asignacin
cfecha &cfecha::operator=(const cfecha &a)
    {
	dia = a.dia;
	mes = a.mes;
	ano = a.ano;

	return (*this);
    }

// Sobrecarga operadores de comparacin
// operador friend de test de igualdad sobrecargado
bool operator==(const cfecha &a, const cfecha &b)
    {
	if(a.dia == b.dia && a.mes == b.mes && a.ano == b.ano)
	    return 1;
	 else
	    return 0;
    }

// operador friend de test de desigualdad sobrecargado
bool operator!=(const cfecha &a, const cfecha &b)
    {
	if(a.dia != b.dia || a.mes != b.mes || a.ano != b.ano)
	    return 1;
	 else
	    return 0;
    }

// Sobrecarga de operador friend <<
ostream &operator<<(ostream &co, const cfecha &a)
    {
	co << a.getday() << setfill('0') << setw(2) << a.dia << "/";
	co << setw(2) << a.mes << "/" << setw(4) << a.ano << setfill(' ');

	return co;
    }

// funcin miembro esttica sumadiames()
int cfecha::sumadiames(int fin)
    {
    	int i, suma = 0;
    	
    	for(i = 1; i <= fin; i++)			// suma de das desde Enero = 1, hasta
    	    suma = suma + diames[i];			// el nmero de mes indicado por fin
    	
    	return suma;					// retorno de nmero total de das
    };

// funcin miembro esttica restaura()
cfecha cfecha::restaura(double dias)
    {
    	cfecha a;    	
    	
    	a.ano = int(dias/1461) * 4;			// 1461 = 365*4 + 1   das en cuatro aos
    	dias = dias - (a.ano/4 * 1461);
    	if(dias != 0)
    	    {
    	    	if(dias == 60)				// traspaso de das a aos, meses y das
    	    	    {
    	    	    	a.mes = 2;			// guardando resultado en objeto cfecha
    	    	    	a.dia = 29;
    	    	    }
    	    	 else
    	    	    {
    	    	    	if(dias > 60)
    	    	    	    --dias;
    	    	    	a.ano = a.ano + int(dias/365);
    	    	    	dias = dias - int(dias/365) * 365;
    	    	    	a.mes = 1;
    	    	    	while(dias > diames[a.mes])
    	    	    	    {
    	    	    	    	dias = dias - diames[a.mes];
    	    	    	    	++a.mes;
    	    	    	    	if(a.mes == 13)
    	    	    	    	    {
    	    	    	    	    	a.mes = 1;
    	    	    	    	    	++a.ano;
    	    	    	    	    }
    	    	    	    }
    	    	    	a.dia = int(dias);
    	    	    }
    	    }
    	 else
    	    {
		a.mes = 1;
		a.dia = 1;
    	    }    	
    	return a;			// retorno de objeto cfecha, con el resultado del traspaso
    };					// 		de das a aos, meses y das.
