//	archivo	cfecha.h
//	declaracin de la clase cfecha

#ifndef __CFECHA_H
#define __CFECHA_H

#include <iostream.h>

class	cfecha
    {
	public:
// Constructores
		cfecha(void);
		cfecha(int d, int m, int a = 2001);
		cfecha(const cfecha &);

// SetThings
		void	setdate(void);		// ingreso de da, mes y ao
		void	setday(int);
		void	setmonth(int);
		void	setyear(int);

// GetThings
		char	*getday(void) const;	// retorno de da de la semana
		int	getnday(void) const;	// retorno de da (1 .. 31)
		int	getmonth(void) const;
		int	getyear(void) const;

// Funcin miembro esttica today()
// retorna referencia a objeto cfecha,con la fecha actual

	static	cfecha today(void);		// retorno de objeto cfecha con la fecha de hoy

// Sobrecarga operadores aritmticos
		cfecha	operator+(const cfecha &);
		cfecha	operator-(const cfecha &);
		void 	operator++(void);		// incremento de fecha en un da
		void 	operator--(void);		// decremento de fecha en un da

// Sobrecarga operador de asignacin
		cfecha& operator=(const cfecha &);

// Sobrecarga operadores de comparacin
	friend	bool	operator==(const cfecha &, const cfecha &);
	friend	bool	operator!=(const cfecha &, const cfecha &);

// Sobrecarga operador de insercin en el flujo de salida
	friend	ostream& operator<<(ostream &, const cfecha &);
	
// Funciones miembro utilitarias

// Funcin miembro esttica sumadiames(int mes)
// retorna el nmero de das desde Enero (=1), hasta el mes indicado en el argumento.
	static	int	sumadiames(int);

// Funcin miembro esttica restaura(double dias)
// retorna un ebjeto cfecha, con aos meses y das, que corresponden
// al nmero de das ingresados en el argumento.
	static	cfecha	restaura(double);

	private: 
		int	dia; 
		int	mes; 
		int	ano;
	static	int 	diames[13];		// arreglo con nmero de das de cada mes.
	static	char 	*semana[7];		// arreglo con das de la semana.
     };

# endif
