// archivo chora.cpp
// funciones y operadores de la clase chora

#include <time.h>		// time(); localtime();
#include <iomanip.h>		// setw(int w); setfill(char c);
#include "chora.h"

 // Constructor por defecto
chora::chora(void)
    {
	second = 0;
	minute = 0;			// hora por defecto
	hour = 0;
	carry = 0;
    }

// Constructor general
chora::chora(int h, int m, int s)
    {
	second = s;
	minute = m;
	hour = h;
	carry = 0;
    }

// Constructor de copia
chora::chora(const chora &a)
    {
	second = a.second;
	minute = a.minute;
	hour = a.hour;
	carry = a.carry;
    }

					// SetThings
// funcin miembro settime()
void chora::settime(void)
    {
	cout << "\n\tIntroduzca las horas (0 .. 23): ";
	cin >> hour;
	cout << "\n\tIntroduzca los minutos: ";			// ingreso de horas, minutos y segundos
	cin >> minute;
	cout << "\n\tIntroduzca los segundos: ";
	cin >> second;
    }

// funcin miembro setsecond()
void chora::setsecond(int s)
    {
	second = s;
    }

// funcin miembro setminute()
void chora::setminute(int m)
    {
	minute = m;
    }

// funcin miembro sethour()
void chora::sethour(int h)
    {
	hour = h;
    }

					// GetThings
// funcin miembro getsecond()
int chora::getsecond(void) const
    {
	return second;
    }

// funcin miembro getminute()
int chora::getminute(void) const
    {
	return minute;
    }

// funcin miembro gethour()
int chora::gethour(void) const
    {
	return hour;
    }

// funcin miembro getcarry()
bool chora::getcarry(void) const
    {
	return carry;					// retorno de bit de under - overflow
    }

// Funcin miembro esttica now()
// retorna referencia a objeto chora,con la hora actual
chora chora::now(void)
    {
    	time_t	now;
    struct tm	*ptm;
    	chora	ahora;
    	
    	time(&now);					// uso de time() y localtime() para la
    	ptm = localtime(&now);				//    obtencin de la hora actual
    	
    	ahora.second = ptm->tm_sec;			// asignacin de horas, minutos y segundos
    	ahora.minute = ptm->tm_min;			//     en objeto de la clase chora
    	ahora.hour = ptm->tm_hour;
    	
    	return ahora;					// retorno de objeto con la hora actual
    }

// Sobrecarga operadores aritmticos
// operador miembro + sobrecargado
chora chora::operator+(const chora &a)
    {
	int x, y;
	chora suma;
	                                                // 3600 = 60*60 segundos de una hora
	suma.carry = 0;
	x = hour*3600 + minute*60 + second;		// traspaso a segundos de operando 1
	y = a.hour*3600 + a.minute*60 + a.second;	// traspaso a segundos de operando 2
	
	x = x + y;					// suma de operandos 1 y 2
	
	suma.hour = int(x/3600);
	x = x - suma.hour*3600;
	if(suma.hour > 23)				// traspaso de segundos a horas,
	    {
	    	suma.hour = suma.hour - 24;		// 	minutos y segundos
	    	suma.carry = 1;
	    }
	suma.minute = int(x/60);
	x = x - suma.minute*60;
	suma.second = x;
	
	return suma;					// retorno de objeto con el
    }							//   resultado de la suma

// operador miembro - sobrecargado
chora chora::operator-(const chora &a)
    {
	int x, y;
	chora resta;
	
	resta.carry = 0;
	x = hour*3600 + minute*60 + second;		// traspaso a segundos de operando 1
	y = a.hour*3600 + a.minute*60 + a.second;	// traspaso a segundos de operando 2
	
	x = x - y;					// resta de operandos 1 y 2
	
	if(x < 0)
	    {
	    	x = x + 86400;				// 86400 = 24*60*60  segundos de un da.
	    	resta.carry = 1;
	    }
	resta.hour = int(x/3600);
	x = x - resta.hour*3600;			// traspaso de segundos a horas,
	resta.minute = int(x/60);
	x = x - resta.minute*60;			// 	minutos y segundos
	resta.second = x;
	
	return resta;					// retorno de objeto con el
    }							//   resultado de la resta

// Sobrecarga pre operador de incremento ++
void chora::operator++(void)
    {
    	carry = 0;
    	second++;					// incremento de hora en un segundo
    	if(second == 60)
    	    {
    	    	second = 0;
    	    	minute++;
    	    	if(minute == 60)
    	    	    {
    	    	    	minute = 0;
    	    	    	hour++;
    	    	    	if(hour == 24)
    	    	    	    {
    	    	    	    	hour = 0;
    	    	    	    	carry = 1;
    	    	    	    }
    	    	    }
    	    }
    }

// Sobrecarga pre operador de decremento --
void chora::operator--(void)
    {
    	carry = 0;
    	second--;					// decremento de hora en un segundo
    	if(second == -1)
    	    {
    	    	second = 59;
    	    	minute--;
    	    	if(minute == -1)
    	    	    {
    	    	    	minute = 59;
    	    	    	hour--;
    	    	    	if(hour == -1)
    	    	    	    {
    	    	    	    	hour = 23;
    	    	    	    	carry = 1;
    	    	    	    }
    	    	    }
    	    }
    }

// Sobrecarga operador de asignacin
chora &chora::operator=(const chora &a)
    {
	second = a.second;
	minute = a.minute;
	hour = a.hour;
	carry = a.carry;

	return (*this);
    }

// Sobrecarga operadores de comparacin
// operador friend de test de igualdad sobrecargado
bool operator==(const chora &a, const chora &b)
    {
	if(a.second == b.second && a.minute == b.minute && a.hour == b.hour)
	    return 1;
	 else
	    return 0;
    }

// operador friend de test de desigualdad sobrecargado
bool operator!=(const chora &a, const chora &b)
    {
	if(a.second != b.second || a.minute != b.minute || a.hour != b.hour)
	    return 1;
	 else
	    return 0;
    }

// Sobrecarga de operador friend <<
ostream &operator<<(ostream &co, const chora &a)
    {

	co << setfill('0') << setw(2) << a.hour <<":" << setw(2);
	co << a.minute << ":" << setw(2) << a.second << setfill(' ');

	return co;
    };

