//	archivo	chora.h
//	declaracin de la clase chora

#ifndef __CHORA_H
#define __CHORA_H

#include <iostream.h>

class	chora
    {
	public:	
// Constructores
		chora(void);
		chora(int h, int m, int s = 0);
		chora(const chora &);

// SetThings
		void	settime(void);			// ingreso de horas, minutos y segundos
		void	setsecond(int);
		void	setminute(int);
		void	sethour(int);

// GetThings
		int	getsecond(void) const;
		int	getminute(void) const;
		int	gethour(void) const;
		bool	getcarry(void) const;		// retorno de bit de under - overflow

// Funcin miembro esttica now()
// retorna referencia a objeto chora, con la hora actual

	static	chora now(void);			// retorno de objeto chora con la hora actual 

// Sobrecarga operadores aritmticos
		chora	operator+(const chora &);
		chora	operator-(const chora &);
		void 	operator++(void);		// incremento de hora en un segundo
		void 	operator--(void);		// decremento de hora en un segundo

// Sobrecarga operador de asignacin
		chora& operator=(const chora &);

// Sobrecarga operadores de comparacin
	friend	bool	operator==(const chora &, const chora &);
	friend	bool	operator!=(const chora &, const chora &);

// Sobrecarga operador de insercin en el flujo de salida
	friend	ostream& operator<<(ostream &, const chora &);

	private: 
		int	second;
		int	minute;
		int	hour;
        	bool	carry;				// "bit" de under - overflow 
     };

# endif
