// archivo ctime.cpp
// funciones y operadores de la clase ctime

#include "ctime.h"

 // Constructor por defecto
ctime::ctime(void) {;}

// Constructor general
ctime::ctime(int d, int me, int a, int h, int mi, int s)
    {
    	cfecha 	f1(d, me, a);
    	chora	h1(h, mi, s);
    	
    	fecha = f1;
    	hora = h1;
    }

// Constructor de copia
ctime::ctime(const ctime &a)
    {
	fecha = a.fecha;
	hora = a.hora;
    }

					// SetThings
// funcin miembro setdate()
void ctime::setdate(void)
    {
	fecha.setdate();			// ingreso de da, mes y ao
    }

// funcin miembro settime()
void ctime::settime(void)
    {
	hora.settime();				// ingreso de horas, minutos y segundos
    }

// funcin miembro setalltime()
void ctime::setalltime(void)
    {
	fecha.setdate();			// ingreso de fecha y hora
	hora.settime();
    }

					// GetThings
// funcin miembro getdate()
void ctime::getdate(void) const
    {
	cout << fecha;				// retorno de da/mes/ao
    }

// funcin miembro gettime()
void ctime::gettime(void) const
    {
	cout << hora;				// retorno de horas:minutos:segundos
    }

// funcin miembro getday()
char *ctime::getday(void) const
    {
	return fecha.getday();			// retorno de da de la semana
    }

// funcin miembro getnday()
int ctime::getnday(void) const
    {
	return fecha.getnday();			// retorno de da (1 .. 31)
    }

// funcin miembro getmonth()
int ctime::getmonth(void) const
    {
	return fecha.getmonth();
    }

// funcin miembro getyear()
int ctime::getyear(void) const
    {
	return fecha.getyear();
    }

// funcin miembro getsecond()
int ctime::getsecond(void) const
    {
	return hora.getsecond();
    }

// funcin miembro getminute()
int ctime::getminute(void) const
    {
	return hora.getminute();
    }

// funcin miembro gethour()
int ctime::gethour(void) const
    {
	return hora.gethour();
    }

// Funcin miembro esttica now()
// retorna referencia a objeto ctime,con la fecha y hora actual
ctime ctime::now(void)
    {
    	ctime	tiempo;
	
	tiempo.fecha = tiempo.fecha.today();		// captura de fecha de hoy
	tiempo.hora = tiempo.hora.now();		// captura de hora actual
    	
    	return tiempo;					// retorno de objeto con la fecha y hora actual
    }

// Sobrecarga operadores aritmticos
// operador miembro + sobrecargado
ctime ctime::operator+(const ctime &a)
    {
	ctime 	suma;
	
	suma.hora = hora + a.hora;			// suma de objetos chora
	suma.fecha = fecha + a.fecha;			// suma de objetos cfecha
	if(suma.hora.getcarry())
	   ++suma.fecha;				// incremento de fecha en un da
	
	return suma;					// retorno de objeto ctime con
    }							//    resultado de la suma

// operador miembro - sobrecargado
ctime ctime::operator-(const ctime &a)
    {
	ctime resta;
	
	resta.hora = hora - a.hora;			// resta de objetos chora
	resta.fecha = fecha - a.fecha;			// resta de objetos cfecha
	if(resta.hora.getcarry())
	    --resta.fecha;				// decremento de fecha en un da
	
	return resta;					// retorno de objeto ctime con
    }							//    resultado de la resta

// operador miembro / sobrecargado
ctime ctime::operator/(const int n)
    {
	double	x, y;
	ctime	div;
								// traspaso de tiempo a segundos
	x = fecha.getyear()*365 + int(fecha.getyear()/4) + div.fecha.sumadiames(fecha.getmonth()-1) + fecha.getnday();
	if(fecha.getyear()%4 > 0 || (fecha.getyear()%4 == 0 && fecha.getmonth() > 2))
	    ++x;
	x = x * 86400;						// 86400 = 24*60*60  segundos de un da..
	
	x = x + hora.gethour()*3600 + hora.getminute()*60 + hora.getsecond();  // n total de segundos.
	
	x = x / n;						// Divisin.
	
	y = int(x / 86400);					// nmero de das del resultado.
	div.fecha = div.fecha.restaura(double(y));              // traspaso de das a fecha.
	y = y * 86400;
	x = int(x - y);                                         // segundos menores a un da.
	
	div.hora.sethour(int(x/3600));                          // construccin de hora
	x = x - div.hora.gethour()*3600;       			//         con
	div.hora.setminute(int(x/60));                          // segundos sobrantes.
	x = x - div.hora.getminute()*60;
	div.hora.setsecond(x);
	
	return div;					// retorno de objeto ctime con el resultado
    }							// 	de la divisin por entero n

// Sobrecarga pre operador de incremento ++
void ctime::operator++(void)				// incremento de tiempo en un segundo
    {
	++hora;						// incremento de hora en un segundo
	if(hora.getcarry())
    	    ++fecha;					// incremento de fecha en un da
    }

// Sobrecarga pre operador de decremento --
void ctime::operator--(void)				// decremento de tiempo en un segundo
    {
	--hora;						// decremento de hora en un segundo
	if(hora.getcarry())
	    --fecha;					// decremento de fecha en un da
    }

// Sobrecarga operador de asignacin
ctime &ctime::operator=(const ctime &a)
    {
	fecha = a.fecha;
	hora = a.hora;

	return (*this);
    }

// Sobrecarga operadores de comparacin
// operador friend de test de igualdad sobrecargado
bool operator==(const ctime &a, const ctime &b)
    {
	if(a.fecha == b.fecha && a.hora == b.hora)
	    return 1;
	 else
	    return 0;
    }

// operador friend de test de desigualdad sobrecargado
bool operator!=(const ctime &a, const ctime &b)
    {
	if(a.fecha != b.fecha || a.hora != b.hora)
	    return 1;
	 else
	    return 0;
    }

// Sobrecarga de operador friend <<
ostream &operator<<(ostream &co, const ctime &a)
    {
    	co << a.fecha << "   ";
    	co << a.hora;
    		
    	return co;
    };

