//	archivo	ctime.h
//	declaracin de la clase ctime

#ifndef __CTIME_H
#define __CTIME_H

#include <iostream.h>
#include "cfecha.h"
#include "chora.h"

class	ctime
    {
	public:	
// Constructores
		ctime(void);
		ctime(int d, int me, int a, int h, int mi, int s = 0);
		ctime(const ctime &);

// SetThings
		void	setdate(void);		// ingreso de da, mes y ao 
		void	settime(void);		// ingreso de horas, minutos y segundos 
		void	setalltime(void);	// ingreso de fecha y hora

// GetThings
		void	getdate(void) const;	// retorno de da/mes/ao  
		void	gettime(void) const;	// retorno de horas:minutos:segundos  
		char	*getday(void) const;	// retorno de da de la semana 
		int	getnday(void) const;	// retorno de da (1 .. 31) 
		int	getmonth(void) const; 
		int	getyear(void) const; 
		int	getsecond(void) const; 
		int	getminute(void) const; 
		int	gethour(void) const; 

// Funcin miembro esttica now()
// retorna referencia a objeto ctime, con la fecha y hora actual

	static	ctime	now(void);		// retorno de objeto con la fecha y hora actual

// Sobrecarga operadores aritmticos
		ctime	operator+(const ctime &);
		ctime	operator-(const ctime &);
		ctime	operator/(const int);		// divisin de objeto ctime por entero
		void 	operator++(void);		// incremento de tiempo en un segundo
		void 	operator--(void);		// decremento de tiempo en un segundo

// Sobrecarga operador de asignacin
		ctime &operator=(const ctime &);

// Sobrecarga operadores de comparacin
	friend	bool	operator==(const ctime &, const ctime &);
	friend	bool	operator!=(const ctime &, const ctime &);

// Sobrecarga operador de insercin en el flujo de salida
	friend	ostream &operator<<(ostream &, const ctime &);
		
	private:
		cfecha	fecha;				// objeto de la clase cfecha
		chora	hora;				// objeto de la clase chora 
     };

# endif
